package cn.fastfun.service.mapper;

import cn.fastfun.service.entity.AppAssetConf;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author jek
 * @since 2021-11-18
 */
public interface AppAssetConfMapper extends BaseMapper<AppAssetConf> {

    @Select("<script>" +
            "SELECT\n" +
            "\td.sn,\n" +
            "\td.amount,\n" +
            "CASE\n" +
            "\t\tCONCAT( d.table_order, d.type ) \n" +
            "\t\tWHEN ( 21 ) THEN\n" +
            "\t\t'故障花费' \n" +
            "\t\tWHEN ( 22 ) THEN\n" +
            "\t\t'平台服务费' \n" +
            "\t\tWHEN ( 31 ) THEN\n" +
            "\t\t'赔偿花费' \n" +
            "\t\tWHEN ( 51 ) THEN\n" +
            "\t\t'仓储费用' \n" +
            "\t\tWHEN ( 52 ) THEN\n" +
            "\t\t'运输费用' \n" +
            "\t\tWHEN ( 53 ) THEN\n" +
            "\t\t'销售费用' \n" +
            "\t\tWHEN ( 54 ) THEN\n" +
            "\t\t'平台费用' \n" +
            "\t\tWHEN ( 61 ) THEN\n" +
            "\t\t'已支付金融成本' \n" +
            "\t\tWHEN ( 62 ) THEN\n" +
            "\t\t'未支付金融成本' \n" +
            "\t\tWHEN ( 71 ) THEN\n" +
            "\t\t'翻新金额-支' \n" +
            "\t\tWHEN ( 72 ) THEN\n" +
            "\t\t'处置支出' \n" +
            "\t\tWHEN ( 73 ) THEN\n" +
            "\t\t'处置收益' \n" +
            "\t\tWHEN ( 81 ) THEN\n" +
            "\t\t'其他支出项目' \n" +
            "\t\tWHEN ( 82 ) THEN\n" +
            "\t\t'其他收入项目' ELSE '其他' \n" +
            "\tEND AS type \n" +
            "FROM\n" +
            "\tapp_asset_conf d " +
            "where sn = #{sn} " +
            "and table_order = #{tableOrder} " +
            "<when test='type!=null'>" +
            "and type in " +
            "<foreach  item=\"item\" collection=\"array\" index=\"index\"  open=\"(\" separator=\",\" close=\")\">#{type}</foreach>" +
            "</when>" +
            "<when test='timeStart!=null'>" +
            "and time > #{timeStart} " +
            "</when>" +
            "<when test='timeEnd!=null'>" +
            "and time < #{timeEnd} " +
            "</when>" +
            "limit #{length}, #{index}" +
            "</script")
    List<AppAssetConf> getAssetConf(@Param("sn") String sn, @Param("tableOrder") Integer tableOrder, @Param("type") String[] type,
                                    @Param("timeStart") String timeStart,@Param("timeEnd") String timeEnd);

}
